(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, allowDevAccounts, sendReferralProgramNotification, roleAssignmentPattern, SandstormDb, appName, addStaticAsset;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
var collectionOptions = { defineMutationMethods: Meteor.isClient };                                                    // 38
// Set to `true` on the client so that method simulation works. Set to `false` on the server                           //
// so that we can be extra certain that all mutations must go through methods.                                         //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       //
//              can be suspended. After some amount of time, the user will be completely deleted                       //
//              and removed from the DB.                                                                               //
//              It is an object with fields:                                                                           //
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        //
//                  chance to still login and reverse the suspension/deletion.                                         //
//                admin: The userId of the admin who suspended the account.                                            //
//                timestamp: Date object. When the suspension occurred.                                                //
//                willDelete: Boolean. If true, this account will be deleted after some time.                          //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 139
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 140
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 141
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 142
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 143
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 144
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 145
Meteor.users.ensureIndexOnServer("suspended.willDelete", { sparse: 1 });                                               // 146
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 149
                                                                                                                       //
Packages = new Mongo.Collection("packages", collectionOptions);                                                        // 151
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions);                                                  // 173
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
//   mountProc: True if the supervisor should mount /proc.                                                             //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions);                                                  // 195
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions);                                                            // 214
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        //
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    //
//              of querying.                                                                                           //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//   size: On-disk size of the grain in bytes.                                                                         //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions);                                          // 248
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions);                                                        // 253
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions);                                                        // 270
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions);                                                    // 300
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions);                                              // 309
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions);                                                  // 333
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions);                                                    // 342
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions);                                                      // 353
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        //
//              so treat this token the same as "trashed". It is denormalized out of Users for                         //
//              ease of querying.                                                                                      //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 492
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 493
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 494
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions);                                                        // 496
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions);                                              // 521
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification (currently only "reportStats").                                            //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions);                              // 557
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 574
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 575
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions);                                                  // 577
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions);                                                                // 586
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions);                                                        // 596
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions);                                                    // 616
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions);                                                // 622
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions);                                      // 636
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions);                                                              // 648
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions);                                                        // 662
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions);                                          // 669
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions);                                                    // 689
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions);                                                // 699
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions);                            // 707
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   //
//                            notification is activated.                                                               //
//   appActivity: Object with fields:                                                                                  //
//     user: {               The user whose action caused this notification.                                           //
//       name: String,       The user's display name.                                                                  //
//       avatarUrl: String,  The URL for the user's profile picture.                                                   //
//     },                                                                                                              //
//     grainId: String,      Which grain this action took place on                                                     //
//     path: String,         The path of the notification.                                                             //
//     body: Util.LocalizedText,  The main body of the activity event.                                                 //
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 //
//                                     { defaultText: "added a comment" }                                              //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 730
  Meteor.publish("credentials", function () {                                                                          // 731
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 734
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 738
          referredIdentityIds: 1, cachedStorageQuota: 1, suspended: 1 } }), Plans.find()];                             // 739
    } else {                                                                                                           // 742
      return [];                                                                                                       // 743
    }                                                                                                                  // 744
  });                                                                                                                  // 745
}                                                                                                                      // 746
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 748
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 749
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 750
};                                                                                                                     // 751
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 753
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 765
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 767
  if (isPaid) {                                                                                                        // 768
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 769
    return { grains: 0,                                                                                                // 770
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 771
  } else {                                                                                                             // 774
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 775
    var bonus = {                                                                                                      // 776
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 777
    };                                                                                                                 // 776
    if (successfulReferralsCount > 0) {                                                                                // 781
      bonus.grains = Infinity;                                                                                         // 782
    } else {                                                                                                           // 783
      bonus.grains = 0;                                                                                                // 784
    }                                                                                                                  // 785
                                                                                                                       //
    return bonus;                                                                                                      // 787
  }                                                                                                                    // 788
};                                                                                                                     // 789
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 791
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 794
  if (user && user.isAdmin) {                                                                                          // 795
    return true;                                                                                                       // 796
  } else {                                                                                                             // 797
    return false;                                                                                                      // 798
  }                                                                                                                    // 799
};                                                                                                                     // 800
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 802
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 805
  if (user && user.isAdmin) {                                                                                          // 806
    return true;                                                                                                       // 807
  } else {                                                                                                             // 808
    return false;                                                                                                      // 809
  }                                                                                                                    // 810
};                                                                                                                     // 811
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 813
  if (!token.requirements) {                                                                                           // 814
    return;                                                                                                            // 815
  }                                                                                                                    // 816
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 818
    return "userIsAdmin" in requirement;                                                                               // 819
  });                                                                                                                  // 820
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 822
    return;                                                                                                            // 823
  }                                                                                                                    // 824
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 826
    return;                                                                                                            // 827
  }                                                                                                                    // 828
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 830
};                                                                                                                     // 831
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 833
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 835
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 836
}                                                                                                                      // 837
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 839
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 844
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 845
  var hostSansPort = host.split(":")[0];                                                                               // 846
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 851
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 852
      return id;                                                                                                       // 853
    }                                                                                                                  // 854
  }                                                                                                                    // 855
                                                                                                                       //
  return null;                                                                                                         // 857
};                                                                                                                     // 858
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 860
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 861
};                                                                                                                     // 862
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 864
  if (hostId) {                                                                                                        // 865
    var split = hostId.split("-");                                                                                     // 866
    if (split[0] === "api") return split[1] || "*";                                                                    // 867
  }                                                                                                                    // 868
                                                                                                                       //
  return false;                                                                                                        // 870
};                                                                                                                     // 871
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 873
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 874
};                                                                                                                     // 875
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 877
if (Meteor.isServer) {                                                                                                 // 878
  (function () {                                                                                                       // 878
    var Crypto = Npm.require("crypto");                                                                                // 879
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 880
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 887
    };                                                                                                                 // 888
  })();                                                                                                                // 878
} else {                                                                                                               // 889
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 890
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 897
  };                                                                                                                   // 898
}                                                                                                                      // 899
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 901
  return "api-" + apiHostIdHashForToken(token);                                                                        // 902
};                                                                                                                     // 903
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 905
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 906
};                                                                                                                     // 907
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 909
  (function () {                                                                                                       // 909
    var Url = Npm.require("url");                                                                                      // 910
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 911
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 919
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 921
      if (dotPos < 0) {                                                                                                // 922
        return protocol + "//*";                                                                                       // 923
      } else {                                                                                                         // 924
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 925
      }                                                                                                                // 926
    };                                                                                                                 // 927
  })();                                                                                                                // 909
}                                                                                                                      // 928
                                                                                                                       //
allowDevAccounts = function allowDevAccounts() {                                                                       // 930
  var setting = Settings.findOne({ _id: "devAccounts" });                                                              // 931
  if (setting) {                                                                                                       // 932
    return setting.value;                                                                                              // 933
  } else {                                                                                                             // 934
    return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;                 // 935
  }                                                                                                                    // 937
};                                                                                                                     // 938
                                                                                                                       //
sendReferralProgramNotification = function sendReferralProgramNotification(userId) {                                   // 940
  Notifications.upsert({                                                                                               // 941
    userId: userId,                                                                                                    // 942
    referral: true                                                                                                     // 943
  }, {                                                                                                                 // 941
    userId: userId,                                                                                                    // 945
    referral: true,                                                                                                    // 946
    timestamp: new Date(),                                                                                             // 947
    isUnread: true                                                                                                     // 948
  });                                                                                                                  // 944
};                                                                                                                     // 950
                                                                                                                       //
roleAssignmentPattern = {                                                                                              // 952
  none: Match.Optional(null),                                                                                          // 953
  allAccess: Match.Optional(null),                                                                                     // 954
  roleId: Match.Optional(Match.Integer),                                                                               // 955
  addPermissions: Match.Optional([Boolean]),                                                                           // 956
  removePermissions: Match.Optional([Boolean])                                                                         // 957
};                                                                                                                     // 952
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 960
  // quotaManager is an object with the following method:                                                              //
  //   updateUserQuota: It is provided two arguments                                                                   //
  //     db: This SandstormDb object                                                                                   //
  //     user: A collections.users account object                                                                      //
  //   and returns a quota object:                                                                                     //
  //     storage: A number (can be Infinity)                                                                           //
  //     compute: A number (can be Infinity)                                                                           //
  //     grains: A number (can be Infinity)                                                                            //
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 970
  this.collections = {                                                                                                 // 971
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    //
    // collection globals directly.                                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
    users: Meteor.users,                                                                                               // 977
                                                                                                                       //
    packages: Packages,                                                                                                // 979
    devPackages: DevPackages,                                                                                          // 980
    userActions: UserActions,                                                                                          // 981
    grains: Grains,                                                                                                    // 982
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 983
    contacts: Contacts,                                                                                                // 984
    sessions: Sessions,                                                                                                // 985
    signupKeys: SignupKeys,                                                                                            // 986
    activityStats: ActivityStats,                                                                                      // 987
    deleteStats: DeleteStats,                                                                                          // 988
    fileTokens: FileTokens,                                                                                            // 989
    apiTokens: ApiTokens,                                                                                              // 990
    apiHosts: ApiHosts,                                                                                                // 991
    notifications: Notifications,                                                                                      // 992
    // Omitted: ActivitySubscriptions                                                                                  //
    statsTokens: StatsTokens,                                                                                          // 994
    misc: Misc,                                                                                                        // 995
    settings: Settings,                                                                                                // 996
    migrations: Migrations,                                                                                            // 997
    // Omitted: StaticAssets                                                                                           //
    // Omitted: AssetUploadTokens                                                                                      //
    plans: Plans,                                                                                                      // 1000
    appIndex: AppIndex,                                                                                                // 1001
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1002
    featureKey: FeatureKey,                                                                                            // 1003
    setupSession: SetupSession,                                                                                        // 1004
    desktopNotifications: DesktopNotifications                                                                         // 1005
  };                                                                                                                   // 971
};                                                                                                                     // 1007
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1012
  isAdmin: isAdmin,                                                                                                    // 1013
  isAdminById: isAdminById,                                                                                            // 1014
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1015
  matchWildcardHost: matchWildcardHost,                                                                                // 1016
  makeWildcardHost: makeWildcardHost,                                                                                  // 1017
  isApiHostId: isApiHostId,                                                                                            // 1018
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1019
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1020
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1021
  makeApiHost: makeApiHost,                                                                                            // 1022
  allowDevAccounts: allowDevAccounts,                                                                                  // 1023
  roleAssignmentPattern: roleAssignmentPattern,                                                                        // 1024
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1026
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1029
    if (user && user.expires) {                                                                                        // 1030
      return true;                                                                                                     // 1031
    } else {                                                                                                           // 1032
      return false;                                                                                                    // 1033
    }                                                                                                                  // 1034
  },                                                                                                                   // 1035
                                                                                                                       //
  isSignedUp: function isSignedUp() {                                                                                  // 1037
    var user = Meteor.user();                                                                                          // 1038
    return this.isAccountSignedUp(user);                                                                               // 1039
  },                                                                                                                   // 1040
                                                                                                                       //
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1042
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1045
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1047
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1049
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1051
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1053
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1055
                                                                                                                       //
    return false;                                                                                                      // 1057
  },                                                                                                                   // 1058
                                                                                                                       //
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1060
    var user = Meteor.user();                                                                                          // 1061
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1062
  },                                                                                                                   // 1063
                                                                                                                       //
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1065
    if (!user) return false; // not signed in                                                                          // 1066
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1068
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1070
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1072
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1074
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1076
                                                                                                                       //
    return false;                                                                                                      // 1078
  },                                                                                                                   // 1079
                                                                                                                       //
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1081
    if (!identity || !identity.services) {                                                                             // 1082
      return false;                                                                                                    // 1083
    }                                                                                                                  // 1084
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1086
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1087
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1088
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1089
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1090
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1091
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1092
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1093
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1094
        return true;                                                                                                   // 1095
      }                                                                                                                // 1096
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1097
      return true;                                                                                                     // 1098
    } else if (samlEnabled && identity.services.saml) {                                                                // 1099
      return true;                                                                                                     // 1100
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1101
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1102
        return true;                                                                                                   // 1103
      }                                                                                                                // 1104
    }                                                                                                                  // 1105
                                                                                                                       //
    return false;                                                                                                      // 1107
  },                                                                                                                   // 1108
                                                                                                                       //
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1110
    if (!this.isFeatureKeyValid()) {                                                                                   // 1111
      return false;                                                                                                    // 1112
    }                                                                                                                  // 1113
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1115
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1116
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1117
        return true;                                                                                                   // 1118
      }                                                                                                                // 1119
    }                                                                                                                  // 1120
                                                                                                                       //
    return false;                                                                                                      // 1122
  }                                                                                                                    // 1123
});                                                                                                                    // 1012
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1126
  (function () {                                                                                                       // 1126
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1127
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1129
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1130
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1133
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1135
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1136
          ApiHosts.remove({ hash2: hash2 });                                                                           // 1137
        }                                                                                                              // 1138
      });                                                                                                              // 1139
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1141
    };                                                                                                                 // 1142
  })();                                                                                                                // 1126
}                                                                                                                      // 1143
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            //
// appears all over the codebase.                                                                                      //
var httpProtocol = void 0;                                                                                             // 1147
if (Meteor.isServer) {                                                                                                 // 1148
  var _Url = Npm.require("url");                                                                                       // 1149
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1150
} else {                                                                                                               // 1151
  httpProtocol = window.location.protocol;                                                                             // 1152
}                                                                                                                      // 1153
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1158
  getUser: function getUser(userId) {                                                                                  // 1159
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1160
    if (userId) {                                                                                                      // 1161
      return Meteor.users.findOne(userId);                                                                             // 1162
    }                                                                                                                  // 1163
  },                                                                                                                   // 1164
                                                                                                                       //
  getIdentity: function getIdentity(identityId) {                                                                      // 1166
    check(identityId, String);                                                                                         // 1167
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1168
    if (identity) {                                                                                                    // 1169
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1170
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1171
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1172
      return identity;                                                                                                 // 1173
    }                                                                                                                  // 1174
  },                                                                                                                   // 1175
                                                                                                                       //
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1177
    check(userId, String);                                                                                             // 1178
    check(identityId, String);                                                                                         // 1179
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1181
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1183
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1184
  },                                                                                                                   // 1185
                                                                                                                       //
  userGrains: function userGrains(userId, options) {                                                                   // 1187
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1188
    check(options, Match.OneOf(undefined, null, { includeTrashOnly: Match.Optional(Boolean), includeTrash: Match.Optional(Boolean) }));
                                                                                                                       //
    var query = { userId: userId };                                                                                    // 1192
    if (options && options.includeTrashOnly) {                                                                         // 1193
      query.trashed = { $exists: true };                                                                               // 1194
    } else if (options && options.includeTrash) {                                                                      // 1195
      // Keep query as-is.                                                                                             //
    } else {                                                                                                           // 1197
        query.trashed = { $exists: false };                                                                            // 1198
      }                                                                                                                // 1199
                                                                                                                       //
    return this.collections.grains.find(query);                                                                        // 1201
  },                                                                                                                   // 1202
                                                                                                                       //
  currentUserGrains: function currentUserGrains(options) {                                                             // 1204
    return this.userGrains(Meteor.userId(), options);                                                                  // 1205
  },                                                                                                                   // 1206
                                                                                                                       //
  getGrain: function getGrain(grainId) {                                                                               // 1208
    check(grainId, String);                                                                                            // 1209
    return this.collections.grains.findOne(grainId);                                                                   // 1210
  },                                                                                                                   // 1211
                                                                                                                       //
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1213
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1214
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1215
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1216
    return this.collections.apiTokens.find({                                                                           // 1217
      "owner.user.identityId": { $in: identityIds },                                                                   // 1218
      trashed: { $exists: !!trashed }                                                                                  // 1219
    });                                                                                                                // 1217
  },                                                                                                                   // 1221
                                                                                                                       //
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1223
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1224
  },                                                                                                                   // 1225
                                                                                                                       //
  userActions: function userActions(user) {                                                                            // 1227
    return this.collections.userActions.find({ userId: user });                                                        // 1228
  },                                                                                                                   // 1229
                                                                                                                       //
  currentUserActions: function currentUserActions() {                                                                  // 1231
    return this.userActions(Meteor.userId());                                                                          // 1232
  },                                                                                                                   // 1233
                                                                                                                       //
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1235
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1236
  },                                                                                                                   // 1237
                                                                                                                       //
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1239
    var grain = this.getGrain(grainId);                                                                                // 1240
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1241
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1243
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1244
    }                                                                                                                  // 1245
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1247
    var grainInfo = { appTitle: appTitle };                                                                            // 1248
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1250
      var icons = pkg.manifest.metadata.icons;                                                                         // 1251
      grainInfo.icon = icons.grain || icons.appGrid;                                                                   // 1252
    }                                                                                                                  // 1253
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1256
      grainInfo.appId = pkg.appId;                                                                                     // 1257
    }                                                                                                                  // 1258
                                                                                                                       //
    return grainInfo;                                                                                                  // 1260
  },                                                                                                                   // 1261
                                                                                                                       //
  getPlan: function getPlan(id) {                                                                                      // 1263
    check(id, String);                                                                                                 // 1264
    var plan = Plans.findOne(id);                                                                                      // 1265
    if (!plan) {                                                                                                       // 1266
      throw new Error("no such plan: " + id);                                                                          // 1267
    }                                                                                                                  // 1268
                                                                                                                       //
    return plan;                                                                                                       // 1270
  },                                                                                                                   // 1271
                                                                                                                       //
  listPlans: function listPlans() {                                                                                    // 1273
    return Plans.find({}, { sort: { price: 1 } });                                                                     // 1274
  },                                                                                                                   // 1275
                                                                                                                       //
  getMyPlan: function getMyPlan() {                                                                                    // 1277
    var user = Meteor.user();                                                                                          // 1278
    return user && Plans.findOne(user.plan || "free");                                                                 // 1279
  },                                                                                                                   // 1280
                                                                                                                       //
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1282
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1287
  },                                                                                                                   // 1288
                                                                                                                       //
  getMyUsage: function getMyUsage(user) {                                                                              // 1290
    user = user || Meteor.user();                                                                                      // 1291
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1292
      if (Meteor.isClient) {                                                                                           // 1293
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1296
      } else {                                                                                                         // 1297
        return {                                                                                                       // 1298
          grains: Grains.find({ userId: user._id }).count(),                                                           // 1299
          storage: user.storageUsage || 0,                                                                             // 1300
          compute: 0 };                                                                                                // 1301
      }                                                                                                                // 1303
    } else // not tracked yet                                                                                          // 1304
      {                                                                                                                // 1304
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1305
      }                                                                                                                // 1306
  },                                                                                                                   // 1307
                                                                                                                       //
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1309
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1310
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1312
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1313
  },                                                                                                                   // 1314
                                                                                                                       //
  getSetting: function getSetting(name) {                                                                              // 1316
    var setting = Settings.findOne(name);                                                                              // 1317
    return setting && setting.value;                                                                                   // 1318
  },                                                                                                                   // 1319
                                                                                                                       //
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1321
    var value = this.getSetting(name);                                                                                 // 1322
    if (value === undefined) {                                                                                         // 1323
      return fallbackValue;                                                                                            // 1324
    }                                                                                                                  // 1325
                                                                                                                       //
    return value;                                                                                                      // 1327
  },                                                                                                                   // 1328
                                                                                                                       //
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1330
    check(userId, String);                                                                                             // 1331
    check(packageId, String);                                                                                          // 1332
                                                                                                                       //
    var pack = Packages.findOne({ _id: packageId });                                                                   // 1334
    if (pack) {                                                                                                        // 1335
      // Remove old versions.                                                                                          //
      var numRemoved = UserActions.remove({ userId: userId, appId: pack.appId });                                      // 1337
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1340
      for (var i in actions) {                                                                                         // 1341
        var action = actions[i];                                                                                       // 1342
        if ("none" in action.input) {                                                                                  // 1343
          var userAction = {                                                                                           // 1344
            userId: userId,                                                                                            // 1345
            packageId: pack._id,                                                                                       // 1346
            appId: pack.appId,                                                                                         // 1347
            appTitle: pack.manifest.appTitle,                                                                          // 1348
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1349
            appVersion: pack.manifest.appVersion,                                                                      // 1350
            title: action.title,                                                                                       // 1351
            nounPhrase: action.nounPhrase,                                                                             // 1352
            command: action.command                                                                                    // 1353
          };                                                                                                           // 1344
          UserActions.insert(userAction);                                                                              // 1355
        } else {                                                                                                       // 1356
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1358
      }                                                                                                                // 1359
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1361
        this.deleteUnusedPackages(pack.appId);                                                                         // 1362
      }                                                                                                                // 1363
    }                                                                                                                  // 1364
  },                                                                                                                   // 1365
                                                                                                                       //
  sendAdminNotification: function sendAdminNotification(message, link) {                                               // 1367
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1368
      Notifications.insert({                                                                                           // 1369
        admin: {                                                                                                       // 1370
          action: link,                                                                                                // 1371
          type: "reportStats"                                                                                          // 1372
        },                                                                                                             // 1370
        userId: user._id,                                                                                              // 1374
        text: { defaultText: message },                                                                                // 1375
        timestamp: new Date(),                                                                                         // 1376
        isUnread: true                                                                                                 // 1377
      });                                                                                                              // 1369
    });                                                                                                                // 1379
  },                                                                                                                   // 1380
                                                                                                                       //
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1382
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1383
  },                                                                                                                   // 1384
                                                                                                                       //
  getServerTitle: function getServerTitle() {                                                                          // 1386
    var setting = Settings.findOne({ _id: "serverTitle" });                                                            // 1387
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1388
  },                                                                                                                   // 1389
                                                                                                                       //
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1391
    var setting = Settings.findOne({ _id: "smtpConfig" });                                                             // 1392
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1393
  },                                                                                                                   // 1394
                                                                                                                       //
                                                                                                                       //
  getReturnAddress: function getReturnAddress() {                                                                      // 1396
    var config = this.getSmtpConfig();                                                                                 // 1397
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1398
  },                                                                                                                   // 1399
                                                                                                                       //
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1401
    check(identityId, String);                                                                                         // 1402
    var identity = this.getIdentity(identityId);                                                                       // 1403
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1404
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1408
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1410
  },                                                                                                                   // 1411
                                                                                                                       //
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1413
    check(accountId, String);                                                                                          // 1414
    check(identityId, String);                                                                                         // 1415
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1417
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1418
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1419
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1420
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1421
      return accountPrimaryEmailAddress;                                                                               // 1422
    } else if (senderPrimaryEmail) {                                                                                   // 1423
      return senderPrimaryEmail.email;                                                                                 // 1424
    } else {                                                                                                           // 1425
      return null;                                                                                                     // 1426
    }                                                                                                                  // 1427
  },                                                                                                                   // 1428
                                                                                                                       //
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1430
    check(accountId, String);                                                                                          // 1431
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1433
    var result = Meteor.users.findAndModify({                                                                          // 1434
      query: { _id: accountId },                                                                                       // 1435
      update: {                                                                                                        // 1436
        $inc: {                                                                                                        // 1437
          dailySentMailCount: 1                                                                                        // 1438
        }                                                                                                              // 1437
      },                                                                                                               // 1436
      fields: { dailySentMailCount: 1 }                                                                                // 1441
    });                                                                                                                // 1434
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1444
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1445
    }                                                                                                                  // 1446
                                                                                                                       //
    var user = result.value;                                                                                           // 1448
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1449
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1454
  },                                                                                                                   // 1455
                                                                                                                       //
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1457
    var featureKey = this.currentFeatureKey();                                                                         // 1458
    return !!featureKey;                                                                                               // 1459
  },                                                                                                                   // 1460
                                                                                                                       //
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1462
    var featureKey = this.currentFeatureKey();                                                                         // 1463
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1464
  },                                                                                                                   // 1465
                                                                                                                       //
  isFeatureKeyOptedIntoStats: function isFeatureKeyOptedIntoStats() {                                                  // 1467
    var featureKey = this.currentFeatureKey();                                                                         // 1468
    return featureKey && featureKey.isTrial && parseInt(featureKey.issued) > 1472601600;                               // 1469
    // 1472601600 is 2016 Aug 31 in seconds since the epoch                                                            //
  },                                                                                                                   // 1471
                                                                                                                       //
  getLdapUrl: function getLdapUrl() {                                                                                  // 1473
    var setting = Settings.findOne({ _id: "ldapUrl" });                                                                // 1474
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1475
  },                                                                                                                   // 1476
                                                                                                                       //
  getLdapBase: function getLdapBase() {                                                                                // 1478
    var setting = Settings.findOne({ _id: "ldapBase" });                                                               // 1479
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1480
  },                                                                                                                   // 1481
                                                                                                                       //
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1483
    var setting = Settings.findOne({ _id: "ldapDnPattern" });                                                          // 1484
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1485
  },                                                                                                                   // 1486
                                                                                                                       //
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1488
    var setting = Settings.findOne({ _id: "ldapSearchUsername" });                                                     // 1489
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1490
  },                                                                                                                   // 1491
                                                                                                                       //
  getLdapNameField: function getLdapNameField() {                                                                      // 1493
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 1494
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1495
  },                                                                                                                   // 1496
                                                                                                                       //
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1498
    var setting = Settings.findOne({ _id: "ldapEmailField" });                                                         // 1499
    return setting ? setting.value : "mail";                                                                           // 1500
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1502
                                                                                                                       //
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1504
    var setting = Settings.findOne({ _id: "ldapExplicitDnSelected" });                                                 // 1505
    return setting && setting.value;                                                                                   // 1506
  },                                                                                                                   // 1507
                                                                                                                       //
  getLdapFilter: function getLdapFilter() {                                                                            // 1509
    var setting = Settings.findOne({ _id: "ldapFilter" });                                                             // 1510
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1511
  },                                                                                                                   // 1512
                                                                                                                       //
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1514
    var setting = Settings.findOne({ _id: "ldapSearchBindDn" });                                                       // 1515
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1516
  },                                                                                                                   // 1517
                                                                                                                       //
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1519
    var setting = Settings.findOne({ _id: "ldapSearchBindPassword" });                                                 // 1520
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1521
  },                                                                                                                   // 1522
                                                                                                                       //
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1524
    var setting = Settings.findOne({ _id: "organizationMembership" });                                                 // 1525
    return setting && setting.value;                                                                                   // 1526
  },                                                                                                                   // 1527
                                                                                                                       //
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1529
    var membership = this.getOrganizationMembership();                                                                 // 1530
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1531
  },                                                                                                                   // 1532
                                                                                                                       //
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1534
    var membership = this.getOrganizationMembership();                                                                 // 1535
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1536
  },                                                                                                                   // 1537
                                                                                                                       //
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1539
    var membership = this.getOrganizationMembership();                                                                 // 1540
    return membership && membership.google && membership.google.enabled;                                               // 1541
  },                                                                                                                   // 1542
                                                                                                                       //
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1544
    var membership = this.getOrganizationMembership();                                                                 // 1545
    return membership && membership.google && membership.google.domain;                                                // 1546
  },                                                                                                                   // 1547
                                                                                                                       //
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1549
    var membership = this.getOrganizationMembership();                                                                 // 1550
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1551
  },                                                                                                                   // 1552
                                                                                                                       //
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1554
    var membership = this.getOrganizationMembership();                                                                 // 1555
    return membership && membership.saml && membership.saml.enabled;                                                   // 1556
  },                                                                                                                   // 1557
                                                                                                                       //
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1559
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1560
  },                                                                                                                   // 1561
                                                                                                                       //
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1563
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1564
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1565
  },                                                                                                                   // 1566
                                                                                                                       //
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1568
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1569
  },                                                                                                                   // 1570
                                                                                                                       //
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1572
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1573
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1574
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1576
    } else {                                                                                                           // 1577
      return setting.value.shareContacts;                                                                              // 1578
    }                                                                                                                  // 1579
  },                                                                                                                   // 1580
                                                                                                                       //
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1582
    var setting = Settings.findOne({ _id: "samlEntryPoint" });                                                         // 1583
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1584
  },                                                                                                                   // 1585
                                                                                                                       //
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1587
    var setting = Settings.findOne({ _id: "samlPublicCert" });                                                         // 1588
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1589
  },                                                                                                                   // 1590
                                                                                                                       //
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1592
    var setting = Settings.findOne({ _id: "samlEntityId" });                                                           // 1593
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1594
  },                                                                                                                   // 1595
                                                                                                                       //
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1597
    return ActivitySubscriptions.find({                                                                                // 1598
      grainId: grainId,                                                                                                // 1599
      threadPath: threadPath || { $exists: false }                                                                     // 1600
    }, {                                                                                                               // 1598
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1602
    }).fetch();                                                                                                        // 1601
  },                                                                                                                   // 1604
                                                                                                                       //
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1606
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1611
    if (threadPath) {                                                                                                  // 1612
      record.threadPath = threadPath;                                                                                  // 1613
    }                                                                                                                  // 1614
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    ActivitySubscriptions.upsert(record, { $set: record });                                                            // 1620
  },                                                                                                                   // 1621
                                                                                                                       //
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1623
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1627
    if (threadPath) {                                                                                                  // 1628
      record.threadPath = threadPath;                                                                                  // 1629
    }                                                                                                                  // 1630
                                                                                                                       //
    ActivitySubscriptions.upsert(record, { $set: { mute: true } });                                                    // 1632
  },                                                                                                                   // 1633
                                                                                                                       //
  updateAppIndex: function updateAppIndex() {                                                                          // 1635
    var _this2 = this;                                                                                                 // 1635
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1636
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1637
    if (!appUpdatesEnabled) {                                                                                          // 1638
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1641
    }                                                                                                                  // 1642
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1644
    var appIndex = this.collections.appIndex;                                                                          // 1645
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1646
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1647
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1650
      app._id = app.appId;                                                                                             // 1651
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1653
      app.hasSentNotifications = false;                                                                                // 1654
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1655
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1656
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this2.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this2.collections.packages.findOne({ _id: app.packageId });                                        // 1660
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1661
        if (pack) {                                                                                                    // 1662
          if (pack.status === "ready") {                                                                               // 1663
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1664
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1665
            } else {                                                                                                   // 1667
              _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1668
            }                                                                                                          // 1670
          } else {                                                                                                     // 1671
            var result = Packages.findAndModify({                                                                      // 1672
              query: { _id: app.packageId },                                                                           // 1673
              update: { $set: { isAutoUpdated: true } }                                                                // 1674
            });                                                                                                        // 1672
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1677
              return;                                                                                                  // 1678
            }                                                                                                          // 1679
                                                                                                                       //
            var newPack = result.value;                                                                                // 1681
            if (newPack.status === "ready") {                                                                          // 1682
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1686
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1687
              } else {                                                                                                 // 1689
                _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
              }                                                                                                        // 1692
            } else if (newPack.status === "failed") {                                                                  // 1693
              // If the package has failed, retry it                                                                   //
              _this2.startInstall(app.packageId, url, true, true);                                                     // 1695
            }                                                                                                          // 1696
          }                                                                                                            // 1697
        } else {                                                                                                       // 1698
          _this2.startInstall(app.packageId, url, false, true);                                                        // 1699
        }                                                                                                              // 1700
      }                                                                                                                // 1701
    });                                                                                                                // 1702
  },                                                                                                                   // 1703
                                                                                                                       //
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1705
    return Settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;                     // 1706
  },                                                                                                                   // 1707
                                                                                                                       //
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1709
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1714
  },                                                                                                                   // 1715
                                                                                                                       //
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1717
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });   // 1718
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1722
  },                                                                                                                   // 1723
                                                                                                                       //
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1725
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1726
    var ret = setting && setting.value || [];                                                                          // 1727
    return _.chain(ret).filter(function (app) {                                                                        // 1728
      return app.status === "ready";                                                                                   // 1729
    }).map(function (app) {                                                                                            // 1729
      return app.appId;                                                                                                // 1730
    }).value();                                                                                                        // 1730
  },                                                                                                                   // 1732
                                                                                                                       //
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1734
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1735
    var ret = setting && setting.value || [];                                                                          // 1736
    return _.map(ret, function (app) {                                                                                 // 1737
      return app.appId;                                                                                                // 1737
    });                                                                                                                // 1737
  },                                                                                                                   // 1738
                                                                                                                       //
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1740
    var _this3 = this;                                                                                                 // 1740
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1741
    appIds.forEach(function (appId) {                                                                                  // 1742
      try {                                                                                                            // 1743
        _this3.addUserActions(userId, _this3.getPackageIdForPreinstalledApp(appId));                                   // 1744
      } catch (e) {                                                                                                    // 1745
        console.error("failed to install app for user:", e);                                                           // 1746
      }                                                                                                                // 1747
    });                                                                                                                // 1748
  },                                                                                                                   // 1749
                                                                                                                       //
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1751
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1755
                                                                                                                       //
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1757
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1764
                                                                                                                       //
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1766
    check(appId, String);                                                                                              // 1767
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1768
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1769
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1770
    if (pack && pack.status === "ready") {                                                                             // 1771
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1772
    } else if (pack && pack.status === "failed") {                                                                     // 1773
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1774
      this.startInstall(packageId, url, true, false);                                                                  // 1775
    } else {                                                                                                           // 1776
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1777
      this.startInstall(packageId, url, false, false);                                                                 // 1778
    }                                                                                                                  // 1779
  },                                                                                                                   // 1780
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1782
    var _this4 = this;                                                                                                 // 1782
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1786
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1789
        value: appAndPackageIds.map(function (data) {                                                                  // 1790
          return {                                                                                                     // 1791
            appId: data.appId,                                                                                         // 1792
            status: "notReady",                                                                                        // 1793
            packageId: data.packageId                                                                                  // 1794
          };                                                                                                           // 1791
        })                                                                                                             // 1796
      } });                                                                                                            // 1789
    appAndPackageIds.forEach(function (data) {                                                                         // 1798
      _this4.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1799
    });                                                                                                                // 1800
  },                                                                                                                   // 1801
                                                                                                                       //
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1803
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1804
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1806
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1807
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1808
  },                                                                                                                   // 1810
                                                                                                                       //
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1812
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1813
  },                                                                                                                   // 1816
                                                                                                                       //
  // Collections                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1818
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1819
    if (!setting || !setting.value) {                                                                                  // 1820
      return true;                                                                                                     // 1821
    }                                                                                                                  // 1822
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1824
    var readyApps = this.collections.packages.find({                                                                   // 1825
      _id: {                                                                                                           // 1826
        $in: packageIds                                                                                                // 1827
      },                                                                                                               // 1826
      status: "ready"                                                                                                  // 1829
    });                                                                                                                // 1825
    return readyApps.count() === packageIds.length;                                                                    // 1831
  },                                                                                                                   // 1832
                                                                                                                       //
  getBillingPromptUrl: function getBillingPromptUrl() {                                                                // 1834
    var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                      // 1835
    return setting && setting.value;                                                                                   // 1836
  },                                                                                                                   // 1837
                                                                                                                       //
  isReferralEnabled: function isReferralEnabled() {                                                                    // 1839
    // This function is a bit weird, in that we've transitioned from                                                   //
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    //
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  //
    return Meteor.settings["public"].quotaEnabled;                                                                     // 1843
  },                                                                                                                   // 1844
                                                                                                                       //
  isQuotaEnabled: function isQuotaEnabled() {                                                                          // 1846
    if (Meteor.settings["public"].quotaEnabled) return true;                                                           // 1847
                                                                                                                       //
    var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                          // 1849
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1850
  },                                                                                                                   // 1851
                                                                                                                       //
  isQuotaLdapEnabled: function isQuotaLdapEnabled() {                                                                  // 1853
    var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                      // 1854
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1855
  },                                                                                                                   // 1856
                                                                                                                       //
  updateUserQuota: function updateUserQuota(user) {                                                                    // 1858
    if (this.quotaManager) {                                                                                           // 1859
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1860
    }                                                                                                                  // 1861
  },                                                                                                                   // 1862
                                                                                                                       //
  getUserQuota: function getUserQuota(user) {                                                                          // 1864
    if (this.isQuotaLdapEnabled()) {                                                                                   // 1865
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1866
    } else {                                                                                                           // 1867
      var plan = Plans.findOne(user.plan || "free");                                                                   // 1868
      var referralBonus = calculateReferralBonus(user);                                                                // 1869
      var bonus = user.planBonus || {};                                                                                // 1870
      var userQuota = {                                                                                                // 1871
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 1872
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 1873
        compute: plan.compute + (bonus.compute || 0)                                                                   // 1874
      };                                                                                                               // 1871
      return userQuota;                                                                                                // 1876
    }                                                                                                                  // 1877
  },                                                                                                                   // 1878
                                                                                                                       //
  isUserOverQuota: function isUserOverQuota(user) {                                                                    // 1880
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     //
    // we will not allow the user to create new grains, though they may be able to open existing ones                  //
    // which may still increase their storage usage.                                                                   //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1887
                                                                                                                       //
    var plan = this.getUserQuota(user);                                                                                // 1889
    if (plan.grains < Infinity) {                                                                                      // 1890
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();      // 1891
      if (count >= plan.grains) return "outOfGrains";                                                                  // 1893
    }                                                                                                                  // 1894
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 1896
  },                                                                                                                   // 1897
                                                                                                                       //
  isUserExcessivelyOverQuota: function isUserExcessivelyOverQuota(user) {                                              // 1899
    // Return true if user is so far over quota that we should prevent their existing grains from                      //
    // running at all.                                                                                                 //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1905
                                                                                                                       //
    var quota = this.getUserQuota(user);                                                                               // 1907
                                                                                                                       //
    // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                           //
    if (quota.grains < Infinity) {                                                                                     // 1910
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 1913
    }                                                                                                                  // 1914
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 1916
  },                                                                                                                   // 1917
                                                                                                                       //
  suspendIdentity: function suspendIdentity(userId, suspension) {                                                      // 1919
    check(userId, String);                                                                                             // 1920
    check(suspension, {                                                                                                // 1921
      timestamp: Date,                                                                                                 // 1922
      admin: Match.Optional(String),                                                                                   // 1923
      voluntary: Match.Optional(Boolean)                                                                               // 1924
    });                                                                                                                // 1921
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1927
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $set: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1930
                                                                                                                       //
  unsuspendIdentity: function unsuspendIdentity(userId) {                                                              // 1932
    check(userId, String);                                                                                             // 1933
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 1935
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $unset: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1938
                                                                                                                       //
  suspendAccount: function suspendAccount(userId, byAdminUserId, willDelete) {                                         // 1940
    var _this5 = this;                                                                                                 // 1940
                                                                                                                       //
    check(userId, String);                                                                                             // 1941
    check(byAdminUserId, Match.OneOf(String, null, undefined));                                                        // 1942
    check(willDelete, Boolean);                                                                                        // 1943
                                                                                                                       //
    var user = globalDb.collections.users.findOne({ _id: userId });                                                    // 1945
    var suspension = {                                                                                                 // 1946
      timestamp: new Date(),                                                                                           // 1947
      willDelete: willDelete || false                                                                                  // 1948
    };                                                                                                                 // 1946
    if (byAdminUserId) {                                                                                               // 1950
      suspension.admin = byAdminUserId;                                                                                // 1951
    } else {                                                                                                           // 1952
      suspension.voluntary = true;                                                                                     // 1953
    }                                                                                                                  // 1954
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1956
    this.collections.grains.update({ userId: userId }, { $set: { suspended: true } }, { multi: true });                // 1957
                                                                                                                       //
    delete suspension.willDelete;                                                                                      // 1959
    // Only mark the parent account for deletion. This makes the query simpler later.                                  //
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 1962
      _this5.suspendIdentity(identity.id, suspension);                                                                 // 1963
    });                                                                                                                // 1964
    user.nonloginIdentities.forEach(function (identity) {                                                              // 1965
      if (_this5.collections.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // Only suspend non-login identities that are unique to this account.                                          //
        _this5.suspendIdentity(identity.id, suspension);                                                               // 1971
      }                                                                                                                // 1972
    });                                                                                                                // 1973
                                                                                                                       //
    // Force logout this user                                                                                          //
    this.collections.users.update({ _id: userId }, { $unset: { "services.resume.loginTokens": 1 } });                  // 1976
    if (user && user.loginIdentities) {                                                                                // 1978
      user.loginIdentities.forEach(function (identity) {                                                               // 1979
        Meteor.users.update({ _id: identity.id }, { $unset: { "services.resume.loginTokens": 1 } });                   // 1980
      });                                                                                                              // 1981
    }                                                                                                                  // 1982
  },                                                                                                                   // 1983
                                                                                                                       //
  unsuspendAccount: function unsuspendAccount(userId) {                                                                // 1985
    var _this6 = this;                                                                                                 // 1985
                                                                                                                       //
    check(userId, String);                                                                                             // 1986
                                                                                                                       //
    var user = globalDb.collections.users.findOne({ _id: userId });                                                    // 1988
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 1989
    this.collections.grains.update({ userId: userId }, { $unset: { suspended: 1 } }, { multi: true });                 // 1990
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 1992
      _this6.unsuspendIdentity(identity.id);                                                                           // 1993
    });                                                                                                                // 1994
                                                                                                                       //
    user.nonloginIdentities.forEach(function (identity) {                                                              // 1996
      _this6.unsuspendIdentity(identity.id);                                                                           // 1997
    });                                                                                                                // 1998
  },                                                                                                                   // 1999
                                                                                                                       //
  deletePendingAccounts: function deletePendingAccounts(deletionCoolingOffTime, backend, cb) {                         // 2001
    var _this7 = this;                                                                                                 // 2001
                                                                                                                       //
    check(deletionCoolingOffTime, Number);                                                                             // 2002
                                                                                                                       //
    var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                     // 2004
    this.collections.users.find({                                                                                      // 2005
      "suspended.willDelete": true,                                                                                    // 2006
      "suspended.timestamp": { $lt: queryDate }                                                                        // 2007
    }).forEach(function (user) {                                                                                       // 2005
      if (cb) cb(_this7, user);                                                                                        // 2009
      _this7.deleteAccount(user._id, backend);                                                                         // 2010
    });                                                                                                                // 2011
  }                                                                                                                    // 2012
});                                                                                                                    // 1158
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2015
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 2020
};                                                                                                                     // 2021
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 2023
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 2026
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2027
  var action = manifest.actions[0];                                                                                    // 2028
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2029
  return appName;                                                                                                      // 2031
};                                                                                                                     // 2032
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 2034
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 2039
    return "(unnamed)";                                                                                                // 2040
  }                                                                                                                    // 2041
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2043
    name = name.slice(4);                                                                                              // 2044
  }                                                                                                                    // 2045
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2047
    name = "Hacker CMS";                                                                                               // 2048
  } else {                                                                                                             // 2049
    var space = name.indexOf(" ");                                                                                     // 2050
    if (space > 0) {                                                                                                   // 2051
      name = name.slice(0, space);                                                                                     // 2052
    }                                                                                                                  // 2053
  }                                                                                                                    // 2054
                                                                                                                       //
  return name;                                                                                                         // 2056
};                                                                                                                     // 2057
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 2059
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2063
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 2065
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 2070
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 2072
    var text = action.title.defaultText;                                                                               // 2073
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2075
      var candidate = text.slice(4);                                                                                   // 2076
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2078
        var newCandidate = candidate.slice(appTitle.length);                                                           // 2079
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 2081
          return newCandidate.toLowerCase();                                                                           // 2082
        } else {                                                                                                       // 2083
          return "grain";                                                                                              // 2084
        }                                                                                                              // 2085
      }                                                                                                                // 2086
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2088
    }                                                                                                                  // 2089
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 2092
  } else {                                                                                                             // 2093
    return "grain";                                                                                                    // 2094
  }                                                                                                                    // 2095
};                                                                                                                     // 2096
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 2100
  appNameFromActionName: appNameFromActionName,                                                                        // 2101
  appNameFromPackage: appNameFromPackage,                                                                              // 2102
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2103
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2104
});                                                                                                                    // 2100
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2107
  (function () {                                                                                                       // 2107
    var cleanupExpiredAssetUploads = function cleanupExpiredAssetUploads() {                                           // 2107
      AssetUploadTokens.remove({ expires: { $lt: Date.now() } });                                                      // 2332
    };                                                                                                                 // 2333
                                                                                                                       //
    // Cleanup tokens every hour.                                                                                      //
                                                                                                                       //
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 2108
    var ContentType = Npm.require("content-type");                                                                     // 2109
    var Zlib = Npm.require("zlib");                                                                                    // 2110
    var Url = Npm.require("url");                                                                                      // 2111
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 2113
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 2115
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 2125
      while (denom <= n) {                                                                                             // 2126
        denom <<= 1;                                                                                                   // 2126
      }var num = n * 2 - denom + 1;                                                                                    // 2126
      return num / denom;                                                                                              // 2128
    };                                                                                                                 // 2129
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 2131
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2133
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2141
      check(callback, Function);                                                                                       // 2142
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2144
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2145
      }                                                                                                                // 2147
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2151
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2155
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 2158
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2160
        callback();                                                                                                    // 2161
        Meteor.setInterval(callback, intervalMs);                                                                      // 2162
      }, first);                                                                                                       // 2163
    };                                                                                                                 // 2164
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2167
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2169
      return Match.Where(function (buf) {                                                                              // 2170
        check(buf, Buffer);                                                                                            // 2171
        return buf.length < limit;                                                                                     // 2172
      });                                                                                                              // 2173
    };                                                                                                                 // 2174
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2176
      check(s, String);                                                                                                // 2177
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2178
    });                                                                                                                // 2179
                                                                                                                       //
    addStaticAsset = function addStaticAsset(metadata, content) {                                                      // 2181
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2185
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2186
        metadata.encoding = "gzip";                                                                                    // 2187
      }                                                                                                                // 2188
                                                                                                                       //
      check(metadata, {                                                                                                // 2190
        mimeType: String,                                                                                              // 2191
        encoding: Match.Optional("gzip")                                                                               // 2192
      });                                                                                                              // 2190
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2194
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2197
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2199
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2200
      hasher.update(content);                                                                                          // 2201
      var hash = hasher.digest("base64");                                                                              // 2202
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2204
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2205
        update: { $inc: { refcount: 1 } },                                                                             // 2206
        fields: { _id: 1, refcount: 1 }                                                                                // 2207
      });                                                                                                              // 2204
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2210
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2211
      }                                                                                                                // 2212
                                                                                                                       //
      var existing = result.value;                                                                                     // 2214
      if (existing) {                                                                                                  // 2215
        return existing._id;                                                                                           // 2216
      }                                                                                                                // 2217
                                                                                                                       //
      return StaticAssets.insert(_.extend({                                                                            // 2219
        hash: hash,                                                                                                    // 2220
        content: content,                                                                                              // 2221
        refcount: 1                                                                                                    // 2222
      }, metadata));                                                                                                   // 2219
    };                                                                                                                 // 2224
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = addStaticAsset;                                                             // 2226
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2228
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2236
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2238
        query: { hash: hash },                                                                                         // 2239
        update: { $inc: { refcount: 1 } },                                                                             // 2240
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2241
      });                                                                                                              // 2238
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2244
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2245
      }                                                                                                                // 2246
                                                                                                                       //
      var existing = result.value;                                                                                     // 2248
      return existing;                                                                                                 // 2249
    };                                                                                                                 // 2250
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2252
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2259
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2261
        query: { _id: id },                                                                                            // 2262
        update: { $inc: { refcount: -1 } },                                                                            // 2263
        fields: { _id: 1, refcount: 1 },                                                                               // 2264
        "new": true                                                                                                    // 2265
      });                                                                                                              // 2261
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2268
        throw new Error("Couldn't unref static asset " + id);                                                          // 2269
      }                                                                                                                // 2270
                                                                                                                       //
      var existing = result.value;                                                                                     // 2272
      if (!existing) {                                                                                                 // 2273
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2274
      } else if (existing.refcount <= 0) {                                                                             // 2275
        StaticAssets.remove({ _id: existing._id });                                                                    // 2276
      }                                                                                                                // 2277
    };                                                                                                                 // 2278
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2280
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2283
                                                                                                                       //
      var asset = StaticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });              // 2285
      if (asset) {                                                                                                     // 2286
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2289
      }                                                                                                                // 2290
                                                                                                                       //
      return asset;                                                                                                    // 2292
    };                                                                                                                 // 2293
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2295
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return AssetUploadTokens.insert({                                                                                // 2301
        purpose: purpose,                                                                                              // 2302
        expires: new Date(Date.now() + 300000) });                                                                     // 2303
    };                                                                                                                 // 2305
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2307
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2311
                                                                                                                       //
      var result = AssetUploadTokens.findAndModify({                                                                   // 2313
        query: { _id: id },                                                                                            // 2314
        remove: true                                                                                                   // 2315
      });                                                                                                              // 2313
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2318
        throw new Error("Failed to remove asset upload token");                                                        // 2319
      }                                                                                                                // 2320
                                                                                                                       //
      var upload = result.value;                                                                                       // 2322
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2324
        return undefined; // already expired                                                                           // 2325
      } else {                                                                                                         // 2326
          return upload.purpose;                                                                                       // 2327
        }                                                                                                              // 2328
    };                                                                                                                 // 2329
                                                                                                                       //
    SandstormDb.periodicCleanup(3600000, cleanupExpiredAssetUploads);                                                  // 2336
                                                                                                                       //
    // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                   //
    var Future = Npm.require("fibers/future");                                                                         // 2339
    var promiseToFuture = function promiseToFuture(promise) {                                                          // 2340
      var result = new Future();                                                                                       // 2341
      promise.then(result["return"].bind(result), result["throw"].bind(result));                                       // 2342
      return result;                                                                                                   // 2343
    };                                                                                                                 // 2344
                                                                                                                       //
    var waitPromise = function waitPromise(promise) {                                                                  // 2346
      return promiseToFuture(promise).wait();                                                                          // 2347
    };                                                                                                                 // 2348
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2350
      var _this8 = this;                                                                                               // 2350
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2353
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2355
      Grains.find(query).forEach(function (grain) {                                                                    // 2356
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2357
        numDeleted += Grains.remove({ _id: grain._id });                                                               // 2358
        _this8.removeApiTokens({                                                                                       // 2359
          grainId: grain._id,                                                                                          // 2360
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2361
        });                                                                                                            // 2359
                                                                                                                       //
        _this8.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2367
                                                                                                                       //
        ActivitySubscriptions.remove({ grainId: grain._id });                                                          // 2369
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2371
          DeleteStats.insert({                                                                                         // 2372
            type: "grain", // Demo grains can never get here!                                                          // 2373
            lastActive: grain.lastUsed,                                                                                // 2374
            appId: grain.appId                                                                                         // 2375
          });                                                                                                          // 2372
        }                                                                                                              // 2377
                                                                                                                       //
        _this8.deleteUnusedPackages(grain.appId);                                                                      // 2379
                                                                                                                       //
        if (grain.size) {                                                                                              // 2381
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2382
        }                                                                                                              // 2383
      });                                                                                                              // 2384
      return numDeleted;                                                                                               // 2385
    };                                                                                                                 // 2386
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2388
      check(grainId, String);                                                                                          // 2389
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2390
      check(identityId, String);                                                                                       // 2391
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2393
      if (!grain) {                                                                                                    // 2394
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2395
      }                                                                                                                // 2396
                                                                                                                       //
      var title = grain.title;                                                                                         // 2398
      if (grain.userId !== accountId) {                                                                                // 2399
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2400
          grainId: grainId,                                                                                            // 2401
          "owner.user.identityId": identityId                                                                          // 2402
        }, {                                                                                                           // 2400
          sort: {                                                                                                      // 2404
            lastUsed: -1                                                                                               // 2405
          }                                                                                                            // 2404
        });                                                                                                            // 2403
        if (sharerToken) {                                                                                             // 2408
          title = sharerToken.owner.user.title;                                                                        // 2409
        } else {                                                                                                       // 2410
          title = "shared grain";                                                                                      // 2411
        }                                                                                                              // 2412
      }                                                                                                                // 2413
                                                                                                                       //
      return title;                                                                                                    // 2415
    };                                                                                                                 // 2416
                                                                                                                       //
    var packageCache = {};                                                                                             // 2418
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2421
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2426
        return packageCache[packageId];                                                                                // 2427
      }                                                                                                                // 2428
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 2430
      if (pkg && pkg.status === "ready") {                                                                             // 2431
        packageCache[packageId] = pkg;                                                                                 // 2432
      }                                                                                                                // 2433
                                                                                                                       //
      return pkg;                                                                                                      // 2435
    };                                                                                                                 // 2436
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2438
      check(appId, String);                                                                                            // 2439
      Packages.find({ appId: appId }).forEach(function (pkg) {                                                         // 2440
        // Mark package for possible deletion;                                                                         //
        Packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });                         // 2442
      });                                                                                                              // 2443
    };                                                                                                                 // 2444
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this = this;                                                                                                // 2448
      var actions = _this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2451
        var userId = action.userId;                                                                                    // 2452
        var updater = {                                                                                                // 2453
          timestamp: new Date(),                                                                                       // 2454
          isUnread: true                                                                                               // 2455
        };                                                                                                             // 2453
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2457
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2461
          marketingVersion: marketingVersion,                                                                          // 2462
          packageId: packageId,                                                                                        // 2463
          name: name,                                                                                                  // 2464
          version: versionNumber                                                                                       // 2465
        };                                                                                                             // 2461
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this.collections.notifications.insert(inserter);                                                            // 2474
        }                                                                                                              // 2475
      });                                                                                                              // 2476
                                                                                                                       //
      _this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                     // 2478
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2482
    };                                                                                                                 // 2483
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = sendReferralProgramNotification;                           // 2485
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2487
      check(appId, String);                                                                                            // 2488
      check(version, Match.Integer);                                                                                   // 2489
      check(packageId, String);                                                                                        // 2490
                                                                                                                       //
      var selector = {                                                                                                 // 2492
        userId: Meteor.userId(),                                                                                       // 2493
        appId: appId,                                                                                                  // 2494
        appVersion: { $lte: version },                                                                                 // 2495
        packageId: { $ne: packageId }                                                                                  // 2496
      };                                                                                                               // 2492
                                                                                                                       //
      Grains.find(selector).forEach(function (grain) {                                                                 // 2499
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2500
      });                                                                                                              // 2501
                                                                                                                       //
      Grains.update(selector, {                                                                                        // 2503
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2504
      }, { multi: true });                                                                                             // 2503
    };                                                                                                                 // 2506
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2508
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2511
        status: "download",                                                                                            // 2512
        progress: 0,                                                                                                   // 2513
        url: url,                                                                                                      // 2514
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2515
      };                                                                                                               // 2511
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2518
        Packages.update({ _id: packageId, status: "failed" }, { $set: fields });                                       // 2519
      } else {                                                                                                         // 2520
        try {                                                                                                          // 2521
          fields._id = packageId;                                                                                      // 2522
          Packages.insert(fields);                                                                                     // 2523
        } catch (err) {                                                                                                // 2524
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2525
        }                                                                                                              // 2526
      }                                                                                                                // 2527
    };                                                                                                                 // 2528
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2530
      check(keyFingerprint, String);                                                                                   // 2531
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2532
    });                                                                                                                // 2533
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2535
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2538
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2540
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2545
      }, function (err, keybaseResponse) {                                                                             // 2544
        if (err) {                                                                                                     // 2547
          console.log("keybase lookup error:", err.stack);                                                             // 2548
          return;                                                                                                      // 2549
        }                                                                                                              // 2550
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2552
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2553
          return;                                                                                                      // 2554
        }                                                                                                              // 2555
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2557
                                                                                                                       //
        if (profile) {                                                                                                 // 2559
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2561
            displayName: (profile.profile || {}).full_name,                                                            // 2562
            handle: (profile.basics || {}).username,                                                                   // 2563
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2564
          };                                                                                                           // 2561
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2568
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2571
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2575
                delete proof[field];                                                                                   // 2576
              }                                                                                                        // 2577
            }                                                                                                          // 2578
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2583
          });                                                                                                          // 2584
                                                                                                                       //
          KeybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });                                  // 2586
        } else {                                                                                                       // 2587
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          KeybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2596
      });                                                                                                              // 2597
    };                                                                                                                 // 2598
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2600
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2603
      var account = Meteor.users.findOne({ "loginIdentities.id": identityId });                                        // 2604
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !Grains.findOne({ userId: account._id }) && !ApiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !Contacts.findOne({ ownerId: account._id })) {
        Meteor.users.remove({ _id: account._id });                                                                     // 2613
        backend.deleteUser(account._id);                                                                               // 2614
      }                                                                                                                // 2615
    };                                                                                                                 // 2616
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2618
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2619
      var db = this.connection.sandstormDb;                                                                            // 2620
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2622
      if (cursor.count() === 0) {                                                                                      // 2623
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2625
      }                                                                                                                // 2626
                                                                                                                       //
      return cursor;                                                                                                   // 2628
    });                                                                                                                // 2629
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2631
      check(appId, String);                                                                                            // 2632
      var db = this.connection.sandstormDb;                                                                            // 2633
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2634
      return cursor;                                                                                                   // 2635
    });                                                                                                                // 2636
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2638
      var _this9 = this;                                                                                               // 2638
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2642
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2654
      var refPackage = function refPackage(packageId) {                                                                // 2655
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2657
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2659
          hasPackage[packageId] = true;                                                                                // 2660
          var pkg = db.getPackage(packageId);                                                                          // 2661
          if (pkg) {                                                                                                   // 2662
            _this9.added("packages", packageId, pkg);                                                                  // 2663
          } else {                                                                                                     // 2664
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2665
          }                                                                                                            // 2667
        }                                                                                                              // 2668
      };                                                                                                               // 2669
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2672
      var actionsHandle = actions.observe({                                                                            // 2673
        added: function added(newAction) {                                                                             // 2674
          refPackage(newAction.packageId);                                                                             // 2675
        },                                                                                                             // 2676
                                                                                                                       //
        changed: function changed(newAction, oldAction) {                                                              // 2678
          refPackage(newAction.packageId);                                                                             // 2679
        }                                                                                                              // 2680
      });                                                                                                              // 2673
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId, { includeTrash: true });                                                 // 2684
      var grainsHandle = grains.observe({                                                                              // 2685
        added: function added(newGrain) {                                                                              // 2686
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2688
            refPackage(newGrain.packageId);                                                                            // 2689
          }                                                                                                            // 2690
        },                                                                                                             // 2691
                                                                                                                       //
        changed: function changed(newGrain, oldGrain) {                                                                // 2693
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2695
            refPackage(newGrain.packageId);                                                                            // 2696
          }                                                                                                            // 2697
        }                                                                                                              // 2698
      });                                                                                                              // 2685
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2701
        actionsHandle.stop();                                                                                          // 2702
        grainsHandle.stop();                                                                                           // 2703
      });                                                                                                              // 2704
                                                                                                                       //
      this.ready();                                                                                                    // 2706
    });                                                                                                                // 2707
  })();                                                                                                                // 2107
}                                                                                                                      // 2708
                                                                                                                       //
var processRawFeatureKey = function processRawFeatureKey(featureKey) {                                                 // 2710
  // Maps the raw data of a signed feature key to the desired "effective" feature key we should use                    //
  // to govern high-level behavior.                                                                                    //
  var processedFeatureKey = _.clone(featureKey);                                                                       // 2713
                                                                                                                       //
  // Hook for future extensibility.                                                                                    //
  return processedFeatureKey;                                                                                          // 2716
};                                                                                                                     // 2717
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2719
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2720
    // Returns an object with all of the current signed feature key properties,                                        //
    // or undefined, if the feature key is missing or not correctly signed.                                            //
    var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                       // 2723
    if (!doc) return undefined;                                                                                        // 2724
    var buf = new Buffer(doc.value);                                                                                   // 2725
    // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                    //
    // once we can use ES6 modules.                                                                                    //
    var rawFeatureKey = loadSignedFeatureKey(buf);                                                                     // 2728
    return processRawFeatureKey(rawFeatureKey);                                                                        // 2729
  };                                                                                                                   // 2730
} else {                                                                                                               // 2731
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2732
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2733
    return processRawFeatureKey(featureKey);                                                                           // 2734
  };                                                                                                                   // 2735
}                                                                                                                      // 2736
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2738
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2739
    check(identityId, String);                                                                                         // 2740
                                                                                                                       //
    this.removeApiTokens({ "owner.user.identityId": identityId });                                                     // 2742
    this.collections.contacts.remove({ identityId: identityId });                                                      // 2743
    Meteor.users.remove({ _id: identityId });                                                                          // 2744
  };                                                                                                                   // 2745
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2747
    check(userId, String);                                                                                             // 2748
                                                                                                                       //
    var _this = this;                                                                                                  // 2750
    var user = Meteor.users.findOne({ _id: userId });                                                                  // 2751
    this.deleteGrains({ userId: userId }, backend, "grain");                                                           // 2752
    this.collections.userActions.remove({ userId: userId });                                                           // 2753
    this.collections.notifications.remove({ userId: userId });                                                         // 2754
    user.loginIdentities.forEach(function (identity) {                                                                 // 2755
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2761
      }                                                                                                                // 2762
    });                                                                                                                // 2763
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2764
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2770
      }                                                                                                                // 2771
    });                                                                                                                // 2772
    this.collections.contacts.remove({ ownerId: userId });                                                             // 2773
    backend.deleteUser(userId);                                                                                        // 2774
    Meteor.users.remove({ _id: userId });                                                                              // 2775
  };                                                                                                                   // 2776
}                                                                                                                      // 2777
                                                                                                                       //
Meteor.methods({                                                                                                       // 2779
  addUserActions: function addUserActions(packageId) {                                                                 // 2780
    check(packageId, String);                                                                                          // 2781
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2782
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2783
    }                                                                                                                  // 2784
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2786
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2789
    } else {                                                                                                           // 2790
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2791
    }                                                                                                                  // 2792
  },                                                                                                                   // 2793
  removeUserAction: function removeUserAction(actionId) {                                                              // 2795
    check(actionId, String);                                                                                           // 2796
    if (this.isSimulation) {                                                                                           // 2797
      UserActions.remove({ _id: actionId });                                                                           // 2798
    } else {                                                                                                           // 2799
      if (this.userId) {                                                                                               // 2800
        var result = UserActions.findAndModify({                                                                       // 2801
          query: { _id: actionId, userId: this.userId },                                                               // 2802
          remove: true                                                                                                 // 2803
        });                                                                                                            // 2801
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2806
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2807
        }                                                                                                              // 2808
                                                                                                                       //
        var action = result.value;                                                                                     // 2810
        if (action) {                                                                                                  // 2811
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2812
        }                                                                                                              // 2813
      }                                                                                                                // 2814
    }                                                                                                                  // 2815
  }                                                                                                                    // 2816
});                                                                                                                    // 2779
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    var email = identity.services.ldap.rawAttrs[SandstormDb.prototype.getLdapEmailField()];                            // 266
    if (email) {                                                                                                       // 267
      return [{ email: email, primary: true }];                                                                        // 268
    }                                                                                                                  // 269
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 270
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 271
  }                                                                                                                    // 272
                                                                                                                       //
  return [];                                                                                                           // 274
};                                                                                                                     // 275
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 277
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 281
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                    // 290
  });                                                                                                                  // 291
};                                                                                                                     // 292
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 294
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 295
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 300
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 302
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 303
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 304
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 308
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 311
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 312
  } else {                                                                                                             // 313
    return [];                                                                                                         // 314
  }                                                                                                                    // 315
};                                                                                                                     // 316
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 318
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 329
  var verifiedEmails = {};                                                                                             // 330
  var unverifiedEmails = {};                                                                                           // 331
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 333
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 334
    if (identity && identity.services) {                                                                               // 335
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 336
        if (verifiedEmail) {                                                                                           // 337
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 338
        }                                                                                                              // 339
      });                                                                                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 343
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 344
    }                                                                                                                  // 345
  });                                                                                                                  // 346
                                                                                                                       //
  var result = [];                                                                                                     // 348
  _.keys(verifiedEmails).map(function (email) {                                                                        // 349
    result.push({ email: email,                                                                                        // 350
      verified: true,                                                                                                  // 351
      primary: email === user.primaryEmail });                                                                         // 352
  });                                                                                                                  // 353
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 355
    if (!(email in verifiedEmails)) {                                                                                  // 356
      result.push({ email: email, verified: false });                                                                  // 356
    }                                                                                                                  // 356
  });                                                                                                                  // 357
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 360
    result[0].primary = true;                                                                                          // 361
  }                                                                                                                    // 362
                                                                                                                       //
  return result;                                                                                                       // 364
};                                                                                                                     // 365
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 367
  check(ownerId, String);                                                                                              // 368
  check(identityId, String);                                                                                           // 369
  var profile = this.getIdentity(identityId).profile;                                                                  // 370
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 371
    ownerId: ownerId,                                                                                                  // 372
    petname: profile && profile.name,                                                                                  // 373
    created: new Date(),                                                                                               // 374
    identityId: identityId                                                                                             // 375
  });                                                                                                                  // 371
};                                                                                                                     // 377
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
